package WebFlow.EventTest1; 

import WebFlow.*; 
import WebFlow.event.*; 
import org.omg.CORBA.*; 
import java.io.*; 
import java.awt.*; 
import java.awt.event.*; 
import java.net.*; 
import java.applet.*; 
import javax.swing.*; 

public class Client
{
    //
    //  Standalone program initialization
    //
    
    public static void main(String args[]) 
    {
	configReader config ; 
	try {
	    ORB orb = ORB.init(args , new java.util.Properties()); 
	    
	    String masterURL = args[0] ; 
	    String ref = getIORFromURL(masterURL); 
	    org.omg.CORBA.Object obj = orb.string_to_object(ref); 
	    if( obj == null)
		throw new RuntimeException(); 

	    WebFlowContext ws = WebFlowContextHelper.narrow(obj); 
	    if( ws == null)
		    throw new RuntimeException() ; 
	    System.out.println("Client: Created WFServerHelper"); 

	    org.omg.CORBA.Object   p1, k1; 
	    WebFlowContext ms_0 , ms_1, ms_2;

	    ms_0 = WebFlowContextHelper.narrow(ws.getContext("TestEventServer"));
	    System.out.println("Client: got ms_0:"+ms_0);
		
	    ms_1 = WebFlowContextHelper.narrow(ws.getContext("TestEventServer/TestEvent_1"));
	    System.out.println("Client: got ms_1:"+ms_1);

	    ms_2 = WebFlowContextHelper.narrow(ws.getContext("TestEventServer/TestEvent_2"));
	    System.out.println("Client: got ms_2:"+ms_2);
		
	    p1 = ms_1.addNewModule("EventTest1");
	    System.out.println("Client: got Action Module");
		
	    k1 = ms_2.addNewModule("EventTest2");
	    System.out.println("Client: got Response Module");

	    EventTest1 act = EventTest1Helper.narrow(p1); 
	    System.out.println(act.test()); 

	    WebFlow.EventTest2.EventTest2 res = WebFlow.EventTest2.EventTest2Helper.narrow(k1); 	
	    System.out.println(res.test()); 

     /* Client register events to specify which module an event comes from,
	   which module and what method an event is received by */

	    ms_1.attachPushEvent(p1,"Fire_Button",k1,"getEvent");
	    ms_1.attachPushEvent(p1,"Reset_Button",k1,"getEvent");
	    ms_1.attachPushEvent(p1, "Quit_Button" , k1 , "getEvent"); 

	    act.runvision1(); 
	    System.out.println("vision1 succeed"); 
		
	    res.runvision2(); 
	    System.out.println("vision2 succeed");
	}
	catch(COMM_FAILURE ex) {
	    System.err.println(ex.getMessage());
	    ex.printStackTrace();
	    System.exit(1);
	}				
			       
    }

    public static String  getIORFromURL(String url) {
	System.out.println("Slave WebFlow is getting IOR from url:"+url);
	String masterServerIOR="";
	String thisLine=null;
	
	//Open the URL for reading
	
	try {
	    URL u = new URL(url);
	    
	    // now turn the URL into a DataInputStream
	    try {
		DataInputStream theHTML = new DataInputStream(u.openStream());
		while((thisLine = theHTML.readLine()) != null) {
		    masterServerIOR += thisLine;
		} // while loop ends here
	    }
	    catch (Exception e) {
		System.out.println("configReader:getIORfromURL:"+e);
	    }
        } // end try
        catch (Exception e) {
	    System.out.println("configReader:getIORfromURL:"+e);
        }
        return masterServerIOR ; 
    }
}
